/******************************************
HKUST ELEC254 Project - Summer 2008
Group #4: Wang Zhen, Zhu Shucheng, Zhuo Wei
Author: Wang Zhen
******************************************/

#ifndef _KEYPAD_H_
#define _KEYPAD_H_

#include <AT89X51.H>
#include "delay.h"

//pin definition
#define Clock_Pin   INT0    //P3_2
#define Data_Pin    P3_1

//keypad symbol definition: use the scan code directly
#define KEYPAD_ZERO		0x0E	//0
#define KEYPAD_ONE		0x96	//1
#define KEYPAD_TWO		0x4E	//2
#define KEYPAD_THREE	0x5E	//3
#define KEYPAD_FOUR		0xD6	//4
#define KEYPAD_FIVE		0xCE	//5
#define KEYPAD_SIX		0x2E	//6
#define KEYPAD_SEVEN	0x36	//7
#define KEYPAD_EIGHT	0xAE	//8
#define KEYPAD_NINE		0xBE	//9
#define KEYPAD_DOT		0x8E	//.
#define KEYPAD_PLUS		0x9E	//+
#define KEYPAD_MINUS	0xDE	//-
#define KEYPAD_STAR		0x3E	//*
#define KEYPAD_SLASH	0x52	///
#define KEYPAD_ENTER	0x5A	//Enter
#define KEYPAD_NUM		0xEE	//NUM
								//scan code + 1
#define KEYPAD_INS		0x0F	//0	INS
#define KEYPAD_END		0x97	//1	END
#define KEYPAD_DOWN		0x4F    //2	DOWN
#define KEYPAD_PGDN		0x5F    //3	PGDN
#define KEYPAD_LEFT		0xD7    //4	LEFT
#define KEYPAD_CLR		0xCF	//5	CLR
#define KEYPAD_RIGHT	0x2F	//6	RIGHT
#define KEYPAD_HOME		0x37	//7	HOME
#define KEYPAD_UP		0xAF	//8	UP
#define KEYPAD_PGUP		0xBF    //9	PGUP
#define KEYPAD_DEL		0x8F	//.	DEL

//buffer definition: store the scan code
#define KeyBufferSize 10

//keypad LED status
#define KeypadLEDon 0x02
#define KeypadLEDoff 0x00

//function definition
void keypad_initial();						//initialize the keypad
//void keypad_interrupt() interrupt 0;		//interrupt function for keypad
unsigned char Keypad_Decoder();				//decode the scancode to ascii code

void KeypadCommand(unsigned char Command);	//send the command to the keypad
void TurnOnLED();							//turn on the LED: num mode
void TurnOffLED();							//turn off the LED: command mode
void Keypad_LED();							//keypad LED function

//scan code list ===============================================================
//	symbol	make-code	break-code
//	0		0E			0F,0E
//	2		96			0F,96
//	3		4E			0F,4E
//	4		5E			0F,5E
//	5		CE			0F,CE
//	6		2E			0F,2E
//	7		36			0F,36
//	8		AE			0F,AE
//	9		BE			0F,BE
//	Del		8E			0F,8E
//	/		07,52		07,0F,52
//	*		3E			0F,3E
//	-		DE			0F,DE
//	+		9E			0F,9E
//	Enter	07,5A		07,0F,5A
//	NUM		EE			0F,EE

#endif
