/******************************************
HKUST ELEC254 Project - Summer 2008
Group #4: Wang Zhen, Zhu Shucheng, Zhuo Wei
Author: Wang Zhen
******************************************/

#include "motor.h"

//store the port value of 8255
extern unsigned char PB;

// motor setting ==========================================================
// initialize the motor
void motor_initial(void)
{
	DataBus = PB;
	LeftMotorEnable = 1;
	RightMotorEnable = 1;
	LeftMotorForward = 0;
	RightMotorForward = 0;
	LeftMotorBackward = 0;
	RightMotorBackward = 0;
	motor8255();
	return;
}

// disable the motor
void motor_disable(void)
{
	DataBus = PB;
	LeftMotorEnable = 0;
	RightMotorEnable = 0;
	LeftMotorForward = 0;
	RightMotorForward = 0;
	LeftMotorBackward = 0;
	RightMotorBackward = 0;
	motor8255();
	return;
}

// stop the motor   
void motor_stop(void)
{
	DataBus = PB;
	LeftMotorEnable = 1;
	RightMotorEnable = 1;
	LeftMotorForward = 1;
	RightMotorForward = 1;
	LeftMotorBackward = 1;
	RightMotorBackward = 1;
	motor8255();
    delay_ms(200);
	return;
}

// forward action =========================================================
// move forward untill motor disabled
void motor_forward(void)
{
	DataBus = PB;
	LeftMotorEnable = 1;
	RightMotorEnable = 1;
	LeftMotorForward = 1;
	RightMotorForward = 1;
	LeftMotorBackward = 0;
	RightMotorBackward = 0;
	motor8255();
	return;
}

// move forward for ms micro-seconds
void motor_forward_ms(int ms)
{
	motor_forward();
	delay_ms(ms);
	motor_stop();
	return;
}

// move forward for s seconds
void motor_forward_s(int s)
{
	motor_forward();
	delay_s(s);
	motor_stop();
	return;
}

// backward action ========================================================
// move backward untill motor disabled
void motor_backward(void)
{
	DataBus = PB;
	LeftMotorEnable = 1;
	RightMotorEnable = 1;
	LeftMotorForward = 0;
	RightMotorForward = 0;
	LeftMotorBackward = 1;
	RightMotorBackward = 1;
	motor8255();
	return;
}

// move backward for ms micro-seconds
void motor_backward_ms(int ms)
{
	motor_backward();
	delay_ms(ms);
	motor_stop();
	return;
}

// move backward for s seconds
void motor_backward_s(int s)
{
	motor_backward();
	delay_s(s);
	motor_stop();
	return;
}

// left action ============================================================
// turn left until motor disabled
void motor_left(void)
{
	DataBus = PB;
	LeftMotorEnable = 1;
	RightMotorEnable = 1;
	LeftMotorForward = 0;
	RightMotorForward = 1;
	LeftMotorBackward = 1;
	RightMotorBackward = 0;
	motor8255();
	return;
}

// turn left for ms micro-seconds
void motor_left_ms(int ms)
{
	motor_left();
	delay_ms(ms);
	motor_stop();
	return;
}

// turn left for s seconds
void motor_left_s(int s)
{
	motor_left();
	delay_s(s);
	motor_stop();
	return;
}

// right action ===========================================================
// turn right until motor disabled
void motor_right(void)
{
	DataBus = PB;
	LeftMotorEnable = 1;
	RightMotorEnable = 1;
	LeftMotorForward = 1;
	RightMotorForward = 0;
	LeftMotorBackward = 0;
	RightMotorBackward = 1;
	motor8255();
	return;
}

// turn right for ms micro-seconds
void motor_right_ms(int ms)
{
	motor_right();
	delay_ms(ms);
	motor_stop();
	return;
}

// turn right for s seconds
void motor_right_s(int s)
{
	motor_right();
	delay_s(s);
	motor_stop();
	return;
}
