/******************************************
HKUST ELEC254 Project - Summer 2008
Group #4: Wang Zhen, Zhu Shucheng, Zhuo Wei
Author: Wang Zhen
******************************************/

#ifndef _MOTOR_H_
#define _MOTOR_H_

#include <AT89X51.H>
#include "setting8255.h"
#include "delay.h"

// left motor control pins
#define LeftMotorEnable P1_0
#define LeftMotorForward P1_1
#define LeftMotorBackward P1_2

// right motor control pins
#define RightMotorEnable P1_5
#define RightMotorForward P1_4
#define RightMotorBackward P1_3

// function decleration	==================================================
// motor setting
void motor_initial(void);		// initialize the motor   
void motor_disable(void);		// disable the motor
void motor_stop(void);			// stop the motor

// forward action
void motor_forward(void);		// move forward untill motor disabled
void motor_forward_ms(int ms);	// move forward for ms micro-seconds
void motor_forward_s(int s);	// move forward for s seconds

// backward action
void motor_backward(void);		// move backward untill motor disabled
void motor_backward_ms(int ms);	// move backward for ms micro-seconds
void motor_backward_s(int s);	// move backward for s seconds

// left action
void motor_left(void);			// turn left until motor disabled
void motor_left_ms(int ms);		// turn left for ms micro-seconds
void motor_left_s(int s);		// turn left for s seconds

// right action
void motor_right(void);			// turn right until motor disabled
void motor_right_ms(int ms);	// turn right for ms micro-seconds
void motor_right_s(int s);		// turn right for s seconds

#endif
