/******************************************
HKUST ELEC254 Project - Summer 2008
Sound Controlled Car
Group #4: Wang Zhen, Zhu Shucheng, Zhuo Wei
Author: Wang Zhen
******************************************/

// A1 A0
// 0  0  Port A -> LCD data bus
// 0  1  Port B -> motor control
// 1  0  Port C -> LCD control
// 1  1  8255 Control

#include "setting8255.h"

//store the port value of 8255
unsigned char PA;
unsigned char PB;
unsigned char PC;

void motor_LCD_8255_initial()
{
	//reset 8255
	RST_8255 = 1;
	RST_8255 = 0;

	//setting
	WR_8255 = 1;
	DataBus = 0x80;
	A0 = 1;
	A1 = 1;
	WR_8255 = 0;
	WR_8255 = 1;	//rising edge

	PA = 0;
	PB = 0;
	PC = 0;
}

void motor8255()
{
	A0 = 1;
	A1 = 0;
	WR_8255 = 0;
	PB = DataBus;
	WR_8255 = 1;
}

void LCD8255_bus()
{
	A0 = 0;
	A1 = 0;
	WR_8255 = 0;
	PA = DataBus;
	WR_8255 = 1;
}

void LCD8255_control()
{
	A0 = 0;
	A1 = 1;
	WR_8255 = 0;
	PC = DataBus;
	WR_8255 = 1;
}

void LED8255_initial()
{
	LED8255_on();
	delay_ms(500);
	LED8255_off();
	delay_ms(500);
	LED8255_menu();
	delay_ms(500);
	LED8255_mode1();
	delay_ms(500);
	LED8255_mode2();
	delay_ms(500);
	LED8255_mode3();
	delay_ms(500);
	LED8255_off();
	delay_s(1);
}

void LED8255_on()
{
	DataBus = 0xA5;
	A0 = 0;
	A1 = 1;
	WR_8255 = 0;
	PC = DataBus;
	WR_8255 = 1;
}

void LED8255_off()
{
	DataBus = 0x00;
	A0 = 0;
	A1 = 1;
	WR_8255 = 0;
	PC = DataBus;
	WR_8255 = 1;
}

void LED8255_menu()
{
	DataBus = 0x80;
	A0 = 0;
	A1 = 1;
	WR_8255 = 0;
	PC = DataBus;
	WR_8255 = 1;

}

void LED8255_mode1()
{
	DataBus = 0x20;
	A0 = 0;
	A1 = 1;
	WR_8255 = 0;
	PC = DataBus;
	WR_8255 = 1;
}

void LED8255_mode2()
{
	DataBus = 0x01;
	A0 = 0;
	A1 = 1;
	WR_8255 = 0;
	PC = DataBus;
	WR_8255 = 1;
}

void LED8255_mode3()
{
	DataBus = 0x04;
	A0 = 0;
	A1 = 1;
	WR_8255 = 0;
	PC = DataBus;
	WR_8255 = 1;
}

