#include "ultrasound.h"

extern unsigned char PB;

uchar ttimer_H;
uchar ttimer_L;
//ulong ultras_dist;

void ultrasound_off(void)
{
	DataBus = PB;
	USGeneratePort = 1;
	motor8255();
	delay_ms(100);
}

void ultrasound_on(void)
{
	DataBus = PB;
	USGeneratePort = 0;
	motor8255();
}

void ultrasound_tx(uchar period_us)  //period_us must e no larger than 255us
{	
	ultrasound_on();
	TMOD = 0x01;
	TH0 = 0xFF;
	TL0 = 0xFF - period_us;	
	TR0 = 1;  
	while (TF0==0) {}
	ultrasound_off();
	TR0 = 0;
	TF0 = 0; 
	TH0=0;
	TL0=0;
		
}
  
unsigned int ultrasound_time(void)
{
       	ultrasound_on();
	TH0=0;
	TL0=0;
	TR0=1; 
		
	while(TF0==0)//
	//while (TF0==1)
	{
		if(USDetectPort)
		{
			ttimer_H=TH0;
			ttimer_L=TL0;
			TR0 = 0;
			TF0 = 0; 
			TH0=0;
			TL0=0;
			ultrasound_off();
			return ttimer_H*256 + ttimer_L;
		} 
	}	
	ttimer_H=0;
	ttimer_L=0;
	TR0 = 0;
	TF0 = 0; 
	TH0=0;
	TL0=0;
	ultrasound_off();
	return 0xFFFF;
}

uint ultrasound_everageTime(void)
{
	uint time1;
	uint time2;
	uint time3;
	
	time1=ultrasound_time();
	time2=ultrasound_time();
	time3=ultrasound_time();
	
	return time1/3+time2/3+time3/3;
	return 0;
}

uchar ultrasound_distance(void)
{
	uint temp_time;
	uchar temp_dist;
	
	temp_time=ultrasound_everageTime();
	temp_dist=temp_time/600;
	
	return temp_dist;
}

bit ultrasound_obstacle(void)
{
	uint temp_time=ultrasound_everageTime();
	if(temp_time<25000)
	{
		return 1;
	}
	else 
	return 0;
}

